/*
    "partagette" est un systeme de déploiment de pages de livres numériques dans l'espace
    Gepeto@du-libre.org licence artlibre (http://artlibre.org)
    V 8 au 4/7/2018
    https://snhack.org/doku.php?id=projets:eparpillage

  Base on FSWebServer - Example WebServer with SPIFFS backend for esp8266
  Copyright (c) 2015 Hristo Gochkov. All rights reserved.
  This file is part of the ESP8266WebServer library for Arduino environment.
  Add on with DNS lib captiv portal
  ?? for file in `ls -A1`; do curl -F "file=@$PWD/$file" esp8266fs.local/edit; done

  fichier prtgeuse.txt.txt 
  #info chipID = 001840EF
  SOURCE_SSID ssid d'ou recupérer les fichiers + config.txt
  SOURCE_PASS
  SOURCE_SITE , url
  PAGES_VERSION , telecharge si nouvelle version , int
  HORAIRES  se met en deepsleep si heure pas bonne ex 9,10,11,12,16,17
  SSID SSID prise par la PARTAGETTE
  PASS mot de passe si existe
  SITEIP IP du site de la partagette
  SITE nom du site de la partagette
  CANAL canal_wifi de 1 a 13
  MAX_CONNEXION nbr de connexion simultanées max =4 (max 8)
  INVISIBLE si 1 SSID invisible
  fichier /listfic.txt  liste des fichiers à récupérer
*/
#include <ESP8266WiFi.h>
#include <WiFiClient.h>
#include <ESP8266HTTPClient.h>
#include <ESP8266WebServer.h>
//#include <ESP8266mDNS.h>
//#include "./DNSServer.h"                  // Patched lib
#include <DNSServer.h>                  // Patched lib
#include "./tools.h"
//#include "./handleHttp.h"
#include <FS.h>
#include <Ticker.h>
#include <Wire.h>
#include <RTClib.h>
#define DBG_OUTPUT_PORT Serial
#define DEBUG
const byte DNS_PORT = 53;          // Capture DNS requests on port 53
/* Soft AP network parameters */
IPAddress apIP(192, 168, 4, 1); // ip source
IPAddress serveurIP(192, 168, 4, 1); // retour du DNS
IPAddress netMsk(255, 255, 255, 0);
DNSServer dnsServer;              // Create the DNS object
/** Should I connect to WLAN asap? */
boolean connect;
/** Last time I tried to connect to WLAN */
int essai_connexion = 0;
long lastConnectTry = 0;
/** Current WLAN status */
int status = WL_IDLE_STATUS;
RTC_DS1307 rtc;
int bouton_init = D8; // GPIO 15 Wemos pull down
bool bouton_init_ok = LOW;
char* nomssid = "PARTAGEOIR"; // SSID pris par la page
char* passssid = "";
char* nomhost = "";
int param_version = 1;
int param_version_flash = 0;
unsigned int CHIP_ID = 0;
String repertoire = "defaut" ;
char* ssid_biblio = "PARTAGEUSE";   // SSID ou chercher les pages
char* password_biblio = "1234567890"; // si existe
String http_site = "http://192.168.4.3/public"; // site web par defaut ou trouver les pages
//String http_site = "http://surla.zone/public"; // site web par defaut ou trouver les pages
int http_port = 80;
int canal_wifi = 1; // channel 1-13
int invisible = 0; // 1 = invisible 0 = visible
int max_connexion = 8; // 4-8 ?
char* horaires = "0,1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,21,22,23";  // heures d'emission ex :9,10,11,12,13,18,19,20
const char *file_param = "prtgeuse.txt"; // .txt passe bien sur les serveurs http
const size_t bufferLen = 80;
const byte BUFFER_SIZE = 80;
char buffer[bufferLen];
int nbr_fic = 0 ; //nbr de fichier de la flash
Ticker tickheure;
bool shouldSaveConfig = true;
const char DEVICE_NAME[] = "PARTAGETTE";
// Global variables
#include <NTPClient.h>

WiFiClient client;
ESP8266WebServer server(80);
//#include <WiFiManager.h>         //https://github.com/tzapu/WiFiManager
#include <WiFiUdp.h>
WiFiUDP ntpUDP;

//holds the current upload
File fsUploadFile;
File list_file;
String responseHTML = ""
                      "<!DOCTYPE html><html><head><title>Portaille captif</title></head><body>"
                      "<h1>Bonjour!</h1><p>Ceci est un portail captif. All requests will "
                      "be redirected here.</p></body></html>";
///// analyse du type de fichier récupéré type mime //////////////////////
String getContentType(String filename) {
  if (server.hasArg("download")) return "application/octet - stream";
  else if (filename.endsWith(".htm")) return "text/html";
  else if (filename.endsWith(".html")) return "text/html";
  else if (filename.endsWith(".cfg")) return "text/html";
  else if (filename.endsWith(".fic")) return "text/html";
  else if (filename.endsWith(".ini")) return "text/html";
  else if (filename.endsWith(".css")) return "text/css";
  else if (filename.endsWith(".otf")) return "font/otf";
  else if (filename.endsWith(".ttf")) return "font/ttf";
  else if (filename.endsWith(".wof")) return "font/wof";
  else if (filename.endsWith(".wof2")) return "font/wof2";
  else if (filename.endsWith(".eot")) return "font/eot";
  else if (filename.endsWith(".js")) return "application/javascript";
  else if (filename.endsWith(".mp3")) return "audio/mpeg3";
  else if (filename.endsWith(".wav")) return "audio/x-wav";
  else if (filename.endsWith(".oga")) return "audio/ogg";
  else if (filename.endsWith(".ogg")) return "audio/ogg";
  else if (filename.endsWith(".avi")) return "video/x-msvideo";
  else if (filename.endsWith(".wbm")) return "video/webm";
  else if (filename.endsWith(".epub")) return "vapplication/epub+zip";
  else if (filename.endsWith(".png")) return "image/png";
  else if (filename.endsWith(".gif")) return "image/gif";
  else if (filename.endsWith(".jpg")) return "image/jpeg";
  else if (filename.endsWith(".ico")) return "image/x - icon";
  else if (filename.endsWith(".xml")) return "text/xml";
  else if (filename.endsWith(".pdf")) return "application/x - pdf";
  else if (filename.endsWith(".zip")) return "application/x - zip";
  else if (filename.endsWith(".gz")) return "application/x - gzip";
  return "text/plain";
}
void tick() {
  //toggle state
  int state = digitalRead(BUILTIN_LED);  // get the current state of GPIO1 pin
  digitalWrite(BUILTIN_LED, !state);     // set pin to the opposite state
}
void saveConfigCallback () { // WiFiManager
  ////DBG_OUTPUT_PORT.println("Should save config");
  shouldSaveConfig = true;
  //DBG_OUTPUT_PORT.println("saving callback config ok");
}
///////////// lecture path et fichier sur la SD ////////////////////
bool handleFileRead(String path) {
  DBG_OUTPUT_PORT.println("handleFileRead:" + path);
  if (path.endsWith("/")) path += "index.html";
  String contentType = getContentType(path);
  String pathWithGz = path + ".gz";
  if (SPIFFS.exists(pathWithGz) || SPIFFS.exists(path)) {
    if (SPIFFS.exists(pathWithGz)) path += ".gz";
    DBG_OUTPUT_PORT.println("ouvre " + path);
    File file = SPIFFS.open(path, "r");
    server.sendHeader("Cache-Control", "no-cache, no-store, must-revalidate");
    server.sendHeader("Pragma", "no-cache");
    server.sendHeader("Expires", "-1");
    size_t sent = server.streamFile(file, contentType);
    file.close();
    return true;
  } else {
    File file = SPIFFS.open("/index.html", "r");
    DBG_OUTPUT_PORT.println("retourne sur /index.html");
    server.sendHeader("Cache-Control", "no-cache, no-store, must-revalidate");
    server.sendHeader("Pragma", "no-cache");
    server.sendHeader("Expires", "-1");
    size_t sent = server.streamFile(file, contentType);
    file.close();
    //server.send(200, "text/plain", index_htm);
    return true;
  }
}
///////////// récupération fichier pour écriture sur la SD ////////////////
void handleFileUpload() {
  if (server.uri() != "/edit") return;
  HTTPUpload& upload = server.upload();
  if (upload.status == UPLOAD_FILE_START) {
    String filename = upload.filename;
    if (!filename.startsWith("/")) filename = "/" + filename;
    DBG_OUTPUT_PORT.print("handleFileUpload Name:");
    DBG_OUTPUT_PORT.println(filename);
    fsUploadFile = SPIFFS.open(filename, "w");
    filename = String();
  } else if (upload.status == UPLOAD_FILE_WRITE) {
    //DBG_OUTPUT_PORT.print("handleFileUpload Data:"); DBG_OUTPUT_PORT.println(upload.currentSize);
    if (fsUploadFile)
      fsUploadFile.write(upload.buf, upload.currentSize);
  } else if (upload.status == UPLOAD_FILE_END) {
    if (fsUploadFile)
      fsUploadFile.close();
    DBG_OUTPUT_PORT.print("handleFileUpload Size:"); DBG_OUTPUT_PORT.println(upload.totalSize);
  }
}
////////////// suppression / création de fichier de la SD /////////////////////
void handleFileDelete() {
  if (server.args() == 0) return server.send(500, "text/plain", "BAD ARGS");
  String path = server.arg(0);
  DBG_OUTPUT_PORT.println("handleFileDelete:" + path);
  if (path == "/")
    return server.send(500, "text/plain", "BAD PATH");
  if (!SPIFFS.exists(path))
    return server.send(404, "text/plain", "FileNotFound");
  SPIFFS.remove(path);
  server.send(200, "text/plain", "");
  path = String();
}
void handleFileCreate() {
  if (server.args() == 0)
    return server.send(500, "text/plain", "BAD ARGS");
  String path = server.arg(0);
  DBG_OUTPUT_PORT.println("handleFileCreate:" + path);
  if (path == "/")
    return server.send(500, "text/plain", "BAD PATH");
  if (SPIFFS.exists(path))
    return server.send(500, "text/plain", "FILE EXISTS");
  File file = SPIFFS.open(path, "w");
  if (file)
    file.close();
  else
    return server.send(500, "text/plain", "CREATE FAILED");
  server.send(200, "text/plain", "");
  path = String();
}
// /dir /////////// liste des fichier de la SD ////////////////////////
void handleFileList() {
  if (!server.hasArg("dir")) {
    server.send(500, "text/plain", "BAD ARGS");
    return;
  }
  String path = server.arg("dir");
  DBG_OUTPUT_PORT.println("handleFileList:" + path);
  Dir dir = SPIFFS.openDir(path);
  path = String();
  String output = "[";
  while (dir.next()) {
    File entry = dir.openFile("r");
    if (output != "[") output += ',';
    bool isDir = false;
    output += "{\"type\":\"";
    output += (isDir) ? "dir" : "file";
    output += "\",\"name\":\"";
    output += String(entry.name()).substring(1);
    output += "\"}";
    entry.close();
  }
  output += "]";
  server.send(200, "text/json", output);
}
////////// télécharge les fichiers de la partageuse //////////////
int Recup_Pages(String page) {
  String url;
  if (repertoire.length() <= 1 ) url = http_site + "/" + page;
  else url = http_site +  "/" + repertoire + "/" + page;
  DBG_OUTPUT_PORT.println(url);

  HTTPClient http;
  http.begin(url);
  //http.begin("http://192.168.4.1/prtgeuse.txt") ;
  //http.begin("http://192.168.4.1/REPERTOIRE/index.html") ;
  //http.begin("http://192.168.4.1/REPERTOIRE/listfic.txt") ;
  int httpCode = http.GET();
  if (httpCode > 0) {
    //fichiers et serveur trouvés
    // HTTP header has been send and Server response header has been handled
    DBG_OUTPUT_PORT.printf("[HTTP] GET... code:%d\n", httpCode);
    if (httpCode == HTTP_CODE_OK || httpCode == -5) {
      // get lenght of document (is -1 when Server sends no Content-Length header)
      int len = http.getSize();
      // create buffer for read
      uint8_t buff[128] = { 0 };
      // get tcp stream
      fsUploadFile = SPIFFS.open(page, "w"); //
      WiFiClient * stream = http.getStreamPtr();
      // read all data from server
      while (http.connected() && (len > 0 || len == -1)) {
        // get available data size
        size_t size = stream->available();
        if (size) {
          // read up to 128 byte
          int c = stream->readBytes(buff, ((size > sizeof(buff)) ? sizeof(buff) : size));
          //DBG_OUTPUT_PORT.write(buff, c);
          fsUploadFile.write(buff, c);
          if (len > 0) {
            len -= c;
          }
        }
        delay(1);
      }
      //DBG_OUTPUT_PORT.println();
      fsUploadFile.flush();
      fsUploadFile.close();
      delay(1000);
      if (SPIFFS.exists(page)) {
        fsUploadFile = SPIFFS.open(page, "r");
        DBG_OUTPUT_PORT.print(page);
        DBG_OUTPUT_PORT.print(" fait ");
        DBG_OUTPUT_PORT.println(fsUploadFile.size());
        fsUploadFile.close();
      }
      DBG_OUTPUT_PORT.print("[HTTP] connection closed or file end.\n");
      http.end();
      return 0;
    }
  } else {
    DBG_OUTPUT_PORT.printf("[HTTP] GET... failed, error:%s\n", http.errorToString(httpCode).c_str());
    http.end();
    return 1;
  }
  http.end();
  return 1;
}
/////////////// test horaire ////////////////////
void Test_horaires() {   // cherche si heure maintenant contenue dans horaires
  int heure = 0 ;
  int taille_plages = strlen(horaires);
  if (taille_plages > 3 ) {
    DateTime now = rtc.now();
    char buf[3] = "00";
    for (int i = 0; i < taille_plages; i++) {
      buf[0] = horaires[i++];
      if (horaires[i] != ',' && horaires[i] != ';' && horaires[i] != ' ') buf[1] = horaires[i++];
      else buf[1] = '\0';
      buf[2] = '\0';
      heure = atoi(buf);
      if ( heure == now.hour() ) {
        heure = 99;
        break;
      }
    }
    int reste = 58 - now.minute();
    if (reste > 3 && heure < 90) {
      DBG_OUTPUT_PORT.println("dodo ");
      ESP.deepSleep(1000000 * 60 * (uint64_t)reste);
    }
  }
}
//////////////////////////////////////////////////
////////// mise a jour des pages /////////////////////
void Mise_a_jour() { // mise a jour de la flash
  DBG_OUTPUT_PORT.println("rerecupere les fichiers de la  liste ");
  delay(1000);
  //for (int i = 0; i < 2; i++) {
  //  essai_connexion = Recup_Pages("edit.htm");
  //  if (essai_connexion == 0 ) {
  //    DBG_OUTPUT_PORT.println("edit.htm ok");
  //    break;
  //  }
  //}
  // re recupere fichier de parametres
  for (int i = 0; i < 5; i++) {
    essai_connexion = Recup_Pages("prtgeuse.txt");
    if (essai_connexion == 0 ) {
      DBG_OUTPUT_PORT.println("prtgeuse.txt ok");
      break;
    }
    delay(1000);
  }
  if (SPIFFS.exists("prtgeuse.txt")) {
    Recup_config(); // pour trouver bon repertoire
    delay(1000);
    // recupere liste des fichiers a recuperer
    for (int i = 0; i < 5; i++) {
      essai_connexion = Recup_Pages("listfic.txt");
      if (essai_connexion == 0 ) break;
      delay(10000);
    }
    delay(1000);
    list_file = SPIFFS.open("listfic.txt", "r");
    if (list_file) {
      String buffer;
      while (list_file.available() > 0 ) { // nbr_fic de ligne de list_file
        buffer = list_file.readStringUntil('\n');
        if ( buffer != "listfic.txt" ) Recup_Pages( buffer);
        nbr_fic++;
      }
      list_file.close();
    } else {
      DBG_OUTPUT_PORT.println("pb ouverture listfic.txt");
    }

  } else {
    DBG_OUTPUT_PORT.println("pas de prtgeuse.txt");

  }
}
////////////// DATE PRINT //////////////////////////////
#define countof(a) (sizeof(a)/sizeof(a[0]))
void printDateTime(const DateTime & dt)
{
  char datestring[20];
  snprintf_P(datestring,
             countof(datestring),
             PSTR(" %04u/%02u/%02u %02u:%02u:%02u"),  // date linux date -s "2018/05/18 15:54:00"
             dt.year(),
             dt.month(),
             dt.day(),
             dt.hour(),
             dt.minute(),
             dt.second() );
  DBG_OUTPUT_PORT.print(datestring);
}
////////// fichiers INI ////////////////////////
int Recup_config(void) {
  int i , buffer_lenght, line_counter = 0 ;
  bool bon_chip = false;
  bool chipok = false;
  char buffer[80], *key, *value;
  delay(100);
  // recherche fichier partageoir.cfg pour y prendre des choses
  File config_file = SPIFFS.open(file_param, "r");
  if (config_file) {
    while (config_file.available() > 0) {
      i = 0;
      while ((buffer[i++] = config_file.read()) != '\n') {
        /* Si la ligne dépasse la taille du buffer */
        if (i == BUFFER_SIZE) {
          /* On finit de lire la ligne mais sans stocker les données */
          while (config_file.read() != '\n');
          break; // Et on arrête la lecture de cette ligne
        }
      }
      buffer_lenght = i;
      /* Gestion des lignes trop grande */
      if (i == BUFFER_SIZE) {
        DBG_OUTPUT_PORT.println("Ligne trop longue à la ligne ");
        DBG_OUTPUT_PORT.println(line_counter, DEC);
        DBG_OUTPUT_PORT.println(i);
      }
      /* Finalise la chaine de caractéres ASCIIZ en supprimant le \n au passage */
      buffer[--i] = '\0';
      /* Incrémente le compteur de lignes */
      ++line_counter;
      /* Ignore les lignes vides ou les lignes de commentaires */
      if (buffer[0] == '\0' || buffer[0] == '#') continue;
      /* Cherche l'emplacement de la clef en ignorant les espaces et les tabulations en début de ligne */
      i = 0;
      while (buffer[i] == ' ' || buffer[i] == '\t') {
        if (++i == buffer_lenght) break; // Ignore les lignes contenant uniquement des espaces et/ou des tabulations
      }
      if (i == buffer_lenght) continue; // Gère les lignes contenant uniquement des espaces et/ou des tabulations
      key = &buffer[i];
      /* Cherche l'emplacement du séparateur = en ignorant les espaces et les tabulations âpres la clef */
      while (buffer[i] != '=') {
        /* Ignore les espaces et les tabulations */
        if (buffer[i] == ' ' || buffer[i] == '\t') buffer[i] = '\0';
        if (++i == buffer_lenght) {
          DBG_OUTPUT_PORT.println("Ligne mal forme a la ligne ");
          DBG_OUTPUT_PORT.println(line_counter, DEC);
          break; // Ignore les lignes mal formé
        }
      }
      if (i == buffer_lenght) continue; // Gère les lignes mal formé
      /* Transforme le séparateur = en \0 et continue */
      buffer[i++] = '\0';
      /* Cherche l'emplacement de la valeur en ignorant les espaces et les tabulations âpres le séparateur */
      while (buffer[i] == ' ' || buffer[i] == '\t') {
        if (++i == buffer_lenght) {
          DBG_OUTPUT_PORT.println("Ligne mal forme a la ligne ");
          DBG_OUTPUT_PORT.println(line_counter, DEC);
          break; // Ignore les lignes mal formé
        }
      }
      if (i == buffer_lenght) continue; // Gère les lignes mal formé
      value = &buffer[i];
      DBG_OUTPUT_PORT.print(key);
      DBG_OUTPUT_PORT.print(" :");
      DBG_OUTPUT_PORT.println(value);
      /* Transforme les données texte en valeur utilisable */
      if (strcmp(key, "PASS") == 0)  sprintf(passssid, "%s", value);
      else if (strcmp(key, "SOURCE_SSID") == 0)  sprintf(ssid_biblio, "%s", value);
      else if (strcmp(key, "SOURCE_PASS") == 0)  sprintf(password_biblio, "%s", value);
      else if (strcmp(key, "SOURCE_SITE") == 0)  http_site = value;
      else if (strcmp(key, "CHIP_ID") == 0) {  // bon serial
        if ( atoi(value) == CHIP_ID && bon_chip == true) {
          /* Ferme le fichier de configuration */
          config_file.close();
          DBG_OUTPUT_PORT.println("fin ");
          return 0;
        }
        if ( atoi(value) == CHIP_ID ) {
          bon_chip = true;
        } else {
          bon_chip = false;
        }
      }
      else if (strcmp(key, "PAGES") == 0 && bon_chip == true)  {
        repertoire =  value ;
        DBG_OUTPUT_PORT.println("OK PAGES ");
        DBG_OUTPUT_PORT.println(repertoire);
      }
      else if (strcmp(key, "SSID") == 0 && bon_chip == true)  sprintf(nomssid, "%s", value);
      else if (strcmp(key, "PASS") == 0 && bon_chip == true)  sprintf(passssid, "%s", value);
      else if (strcmp(key, "SITE") == 0 && bon_chip == true)  sprintf(nomhost, "%s", value);
      else if (strcmp(key, "SITEIP") == 0 && bon_chip == true)  {
        if (isIp(value)) {
          char buf[25] = "";
          strcpy(buf, &buffer[i]);
          byte ip[4] = {0};
          char * item = strtok(buf, ".");
          uint8_t index = 0;
          while (item != NULL) {
            if ((*item >= '0') && (*item <= '9')) {
              ip[index++] = atoi(item);
              DBG_OUTPUT_PORT.print(item);
              DBG_OUTPUT_PORT.print(" ");

            }
            item = strtok(NULL, ".");
          }
          serveurIP = IPAddress( ip[0], ip[1], ip[2], ip[3] );
        }
      }
      else if (strcmp(key, "VERSION") == 0 && bon_chip == true)  param_version = atoi(value);
      else if (strcmp(key, "CANAL") == 0 && bon_chip == true)    canal_wifi = atoi(value);
      else if (strcmp(key, "MAX_CONNEXION") == 0 && bon_chip == true)  max_connexion = atoi(value);
      else if (strcmp(key, "INVISIBLE") == 0 && bon_chip == true)  invisible = atoi(value);
      else if (strcmp(key, "HORAIRES") == 0 && bon_chip == true)  sprintf(horaires, "%s", value);
      else { // Default
        DBG_OUTPUT_PORT.print("Clef inconnu ");
        DBG_OUTPUT_PORT.println(key);
      }
      key = "";
      value = "";
    }
    /* Ferme le fichier de configuration */
    config_file.close();
    DBG_OUTPUT_PORT.println("fin ");
  } else {
    DBG_OUTPUT_PORT.print("pas de fichier ini ");
  }
}
/////////////////////// trucs web ///////////////////////////////////////::
/** Redirect to captive portal if we got a request for another domain. Return true in that case so the page handler do not try to handle the request again. */
boolean captivePortal() {
  if (!isIp(server.hostHeader()) && server.hostHeader() != (String(nomssid) + ".local")) {
    Serial.print("Request redirected to captive portal");
    server.sendHeader("Location", String("http://") + toStringIp(server.client().localIP()), true);
    server.send ( 302, "text/plain", ""); // Empty content inhibits Content-length header so we have to close the socket ourselves.
    server.client().stop(); // Stop is needed because we sent no content length
    return true;
  }
  return false;
}
/** Handle root or redirect to captive portal */
void handleRoot() {
  if (captivePortal()) { // If caprive portal redirect instead of displaying the page.
    return;
  }
  server.sendHeader("Cache-Control", "no-cache, no-store, must-revalidate");
  server.sendHeader("Pragma", "no-cache");
  server.sendHeader("Expires", "-1");
  server.send(200, "text/html", ""); // Empty content inhibits Content-length header so we have to close the socket ourselves.
  server.sendContent(
    "<html><head></head><body>"
    "<h1>HELLO WORLD!!</h1>"
  );
  if (server.client().localIP() == apIP) {
    server.sendContent(String("<p>You are connected through the soft AP: ") + nomssid + "</p>");
  } else {
    server.sendContent(String("<p>You are connected through the wifi network: ") + nomssid + "</p>");
  }
  server.sendContent(
    "<p>You may want to <a href='/wifi'>config the wifi connection</a>.</p>"
    "</body></html>"
  );
  server.client().stop(); // Stop is needed because we sent no content length
}
/** Wifi config page handler */
void handleWifi() {
  server.sendHeader("Cache-Control", "no-cache, no-store, must-revalidate");
  server.sendHeader("Pragma", "no-cache");
  server.sendHeader("Expires", "-1");
  server.send(200, "text/html", ""); // Empty content inhibits Content-length header so we have to close the socket ourselves.
  server.sendContent(
    "<html><head></head><body>"
    "<h1>Wifi config</h1>"
  );
  if (server.client().localIP() == apIP) {
    server.sendContent(String("<p>You are connected through the soft AP: ") + ssid_biblio + "</p>");
  } else {
    server.sendContent(String("<p>You are connected through the wifi network: ") + nomssid + "</p>");
  }
  server.sendContent(
    "\r\n<br />"
    "<table><tr><th align='left'>SoftAP config</th></tr>"
  );
  server.sendContent(String() + "<tr><td>SSID " + String(ssid_biblio) + "</td></tr>");
  server.sendContent(String() + "<tr><td>IP " + toStringIp(WiFi.softAPIP()) + "</td></tr>");
  server.sendContent(
    "</table>"
    "\r\n<br />"
    "<table><tr><th align='left'>WLAN config</th></tr>"
  );
  server.sendContent(String() + "<tr><td>SSID " + String(ssid_biblio) + "</td></tr>");
  server.sendContent(String() + "<tr><td>IP " + toStringIp(WiFi.localIP()) + "</td></tr>");
  server.sendContent(
    "</table>"
    "\r\n<br />"
    "<table><tr><th align='left'>WLAN list (refresh if any missing)</th></tr>"
  );
  Serial.println("scan start");
  int n = WiFi.scanNetworks();
  Serial.print("scan done ");
  Serial.println(n);
  if (n > 0) {
    for (int i = 0; i < n; i++) {
      server.sendContent(String() + "\r\n<tr><td>SSID " + WiFi.SSID(i) + String((WiFi.encryptionType(i) == ENC_TYPE_NONE) ? " " : " *") + " (" + WiFi.RSSI(i) + ")</td></tr>");
    }
  } else {
    server.sendContent(String() + "<tr><td>No WLAN found</td></tr>");
  }
  server.sendContent(
    "</table>"
    "\r\n<br /><form method='POST' action='wifisave'><h4>Connect to network:</h4>"
    "<input type='text' placeholder='network' name='n'/>"
    "<br /><input type='password' placeholder='password' name='p'/>"
    "<br /><input type='submit' value='Connect/Disconnect'/></form>"
    "<p>You may want to <a href='/'>return to the home page</a>.</p>"
    "</body></html>"
  );
  server.client().stop(); // Stop is needed because we sent no content length
}

/** Handle the WLAN save form and redirect to WLAN config page again */
void handleWifiSave() {
  Serial.println("wifi save");
  server.arg("n").toCharArray(ssid_biblio, sizeof(ssid_biblio) - 1);
  server.arg("p").toCharArray(password_biblio, sizeof(password_biblio) - 1);
  server.sendHeader("Location", "wifi", true);
  server.sendHeader("Cache-Control", "no-cache, no-store, must-revalidate");
  server.sendHeader("Pragma", "no-cache");
  server.sendHeader("Expires", "-1");
  server.send ( 302, "text/plain", "");  // Empty content inhibits Content-length header so we have to close the socket ourselves.
  server.client().stop(); // Stop is needed because we sent no content length
}
void handleNotFound() {
  if (captivePortal()) { // If caprive portal redirect instead of displaying the error page.
    return;
  }
  String message = "File Not Found\n\n";
  message += "URI: ";
  message += server.uri();
  message += "\nMethod: ";
  message += ( server.method() == HTTP_GET ) ? "GET" : "POST";
  message += "\nArguments: ";
  message += server.args();
  message += "\n";

  for ( uint8_t i = 0; i < server.args(); i++ ) {
    message += " " + server.argName ( i ) + ": " + server.arg ( i ) + "\n";
  }
  server.sendHeader("Cache-Control", "no-cache, no-store, must-revalidate");
  server.sendHeader("Pragma", "no-cache");
  server.sendHeader("Expires", "-1");
  server.send ( 404, "text/plain", message );
}
//////////////////////////////////////////////////////////////////////////////////
void setup(void) {
  pinMode(BUILTIN_LED, OUTPUT);
  pinMode(bouton_init , INPUT);
  DBG_OUTPUT_PORT.begin(9600);
  DBG_OUTPUT_PORT.print("\n");
  DBG_OUTPUT_PORT.setDebugOutput(true);
  delay(1000);
  CHIP_ID = ESP.getChipId();
  DBG_OUTPUT_PORT.print("ID ");
  DBG_OUTPUT_PORT.println(CHIP_ID);
  delay(2000);
  ////////// HORLOGE RTC_DS3231 rtc;  ou DS1307 et client NTP///////////
  if (! rtc.begin()) {
    DBG_OUTPUT_PORT.println("horloge non connectée! 1");
    delay(1000);
    if (! rtc.begin()) {
      DBG_OUTPUT_PORT.println("horloge non connectée! 2");
      delay(1000);
    }
  }
  if (!rtc.isrunning()) {
    DBG_OUTPUT_PORT.println("RTC is NOT running!");
    // following line sets the RTC to the date & time this sketch was compiled
    DateTime compiled = DateTime(__DATE__, __TIME__);
    printDateTime(compiled);
    rtc.adjust(DateTime(F(__DATE__), F(__TIME__)));
    // This line sets the RTC with an explicit date & time, for example to set
    // January 21, 2014 at 3am you would call:
    // rtc.adjust(DateTime(2014, 1, 21, 3, 0, 0));
  }
  delay(100);
  DateTime now ; //= rtc.now();
  //DBG_OUTPUT_PORT.println("date ");
  //printDateTime(now);
  DBG_OUTPUT_PORT.printf("\n");
  SPIFFS.begin();

  //WIFI connexion aux pages sources
  DBG_OUTPUT_PORT.print("Connexion aux sources...");
  WiFi.softAPConfig(apIP, apIP, netMsk);
  WiFi.mode(WIFI_STA);
  WiFi.begin(ssid_biblio, password_biblio);
  essai_connexion = 0;
  while ( WiFi.status() != WL_CONNECTED ) {
    DBG_OUTPUT_PORT.print(".");
    if (essai_connexion++ >= 5) break; // on sort au bout de 5 s
    delay(1000);
  }
  DBG_OUTPUT_PORT.println(WiFi.localIP());

  ////////////// recup heure NTP si connecte/////////////////////
  NTPClient timeClient(ntpUDP, "ntp.ovh.net", 7200, 60000);
  if (WiFi.status() == WL_CONNECTED) {
    timeClient.begin();
    DBG_OUTPUT_PORT.print("NTP?");
    delay(500);
    for (int i = 0; i >= 3; i++) {
      if (timeClient.update()) {
        String bonheure = timeClient.getFormattedTime();
        DBG_OUTPUT_PORT.println(bonheure);
        rtc.adjust(DateTime(timeClient.getEpochTime()));
        break;
      } else {
        DBG_OUTPUT_PORT.print(".");
      }
    }
    now = rtc.now();
    DBG_OUTPUT_PORT.println("date ");
    printDateTime(now);
    DBG_OUTPUT_PORT.printf("\n");
  }
  ///////////////// si bouton format et mise a jour /////////////////////////:::
  bouton_init_ok = digitalRead(bouton_init);
  if (bouton_init_ok == HIGH || analogRead(A0) > 20 ) {
    DBG_OUTPUT_PORT.println("init formatage");
    SPIFFS.end();
    SPIFFS.format();// supprme tous les fichiers de la flash
    delay(1000);
    SPIFFS.begin();
    DBG_OUTPUT_PORT.println("formatee");

    //   if (WiFi.status() == WL_CONNECTED ) { // si on se connecte on verifi les fichiers
    //     essai_connexion = 0;
    //   }
    DBG_OUTPUT_PORT.println("fin re-init");
  }
  Mise_a_jour();
  WiFi.disconnect();

  delay(1000);
  //////////////////////////////
  DBG_OUTPUT_PORT.println("dir flash");
  Dir dir = SPIFFS.openDir("/");
  char str[14] = "";
  while (dir.next()) {
    String fileName = dir.fileName();
    size_t fileSize = dir.fileSize();
    DBG_OUTPUT_PORT.printf("FS File:%s, size:%s\n", fileName.c_str(), formatBytes(fileSize).c_str());
  }
  DBG_OUTPUT_PORT.printf("\n");

  Recup_config(); // recupere ssid,pass,param_version de la flash
  if (bouton_init_ok == LOW) Test_horaires();    //// si pas dans l'heure deepsleep

  //DBG_OUTPUT_PORT.print("Configuring access point...");
  //delay(500);
  WiFi.disconnect();
  /*
     Set up an access point
    @param ssid              Pointer to the SSID (max 63 char).
    @param passphrase        (for WPA2 min 8 char, for open use NULL)
    @param channel           WiFi channel number, 1 - 13.
    @param ssid_hidden       Network cloaking (0 = broadcast SSID, 1 = hide SSID)
    @param max_connection    Max simultaneous connected clients, 1 - 4.
  */
  if (max_connexion < 1 || max_connexion > 8) max_connexion = 4 ;
  if (invisible = ! 1) invisible = 0 ;
  if (canal_wifi < 1 || canal_wifi > 13) canal_wifi = 1 ;
  WiFi.softAPConfig(serveurIP, serveurIP, netMsk);
  if (strlen(passssid) == 0) {
    WiFi.softAP(nomssid, NULL, canal_wifi, invisible, max_connexion);
    delay(500);
    DBG_OUTPUT_PORT.print("ouverture de ");
    DBG_OUTPUT_PORT.println(nomssid);
  } else {
    WiFi.softAP(nomssid, passssid, canal_wifi, invisible, max_connexion);
    delay(500);
    DBG_OUTPUT_PORT.print("ouverture  et paswd de ");
    DBG_OUTPUT_PORT.print(nomssid);
    DBG_OUTPUT_PORT.print(" ");
    DBG_OUTPUT_PORT.println(passssid);
  }
  delay(100);
  // Setup the DNS server redirecting all the domains to the apIP
  dnsServer.setErrorReplyCode(DNSReplyCode::NoError);
  dnsServer.start(DNS_PORT, "*", apIP);
  DBG_OUTPUT_PORT.print("AP IP address:");
  DBG_OUTPUT_PORT.println(WiFi.softAPIP());
  delay(2000);
  //if (MDNS.begin(nomhost)) {
  //  DBG_OUTPUT_PORT.println("MDNS responder started");
  //}
  DBG_OUTPUT_PORT.println("");
  delay(100);
  //SERVER INIT
  tickheure.attach(900, Test_horaires); // toutes les 15 min test si deepsleep
  ///////////////////////fonction serveur http///////////////////////////////
  //list directory
  server.on("/list", HTTP_GET, handleFileList);
  //////////// detection de portail ////
  server.on("/success.txt", HTTP_GET, []() {
    handleFileRead("/index.html");
  }); // firefox
  server.on("/generate_204", HTTP_GET, []() {
    handleFileRead("/index.html");
  }); // chrome
  server.on("/hotspot-detect.html", HTTP_GET, []() {
    handleFileRead("/index.html");
  }); // ios
  server.on("/ncsi.txt", HTTP_GET, []() {
    handleFileRead("/index.html");
  }); // win
  //////////////
  server.on("/wifi", handleWifi);
  server.on("/wifisave", handleWifiSave);
  server.on("/edit", HTTP_GET, []() {
    if (!handleFileRead("/edit.html")) server.send(404, "text/plain", "FileNotFound");
  });
  //create file
  server.on("/edit", HTTP_PUT, handleFileCreate);
  //delete file
  server.on("/edit", HTTP_DELETE, handleFileDelete);
  //first callback is called after the request has ended with all parsed arguments
  //second callback handles file uploads at that location
  server.on("/edit", HTTP_POST, []() {
    server.send(200, "text/plain", "");
  }, handleFileUpload);
  //called when the url is not defined here
  //use it to load content from SPIFFS
  server.onNotFound([]() {
    if (!handleFileRead(server.uri()))
      server.send(404, "text/plain", "FileNotFound");
  });

  //get heap status, analog input value and all GPIO statuses in one json call
  server.on("/all", HTTP_GET, []() {
    String json = "{";
    json += "\"heap\":" + String(ESP.getFreeHeap());
    json += ", \"analog\":" + String(analogRead(A0));
    json += ", \"gpio\":" + String((uint32_t)(((GPI | GPO) & 0xFFFF) | ((GP16I & 0x01) << 16)));
    json += "}";
    server.send(200, "text/json", json);
    json = String();
  });

  server.begin();
  DBG_OUTPUT_PORT.println("HTTP server started");

}
void loop(void) {
  server.handleClient();
  dnsServer.processNextRequest();
}
